
#define BRIGHTER 1.2

uniform int UseDiffuseTexture;

uniform sampler2D diffuseTexture;
uniform sampler2D cloudShadowTexture;

void main(void)
{
	vec4 col = gl_Color;
	
	// Diffuse texturing is optional.
	
	if (UseDiffuseTexture == 1)
		col *= texture2D(diffuseTexture, gl_TexCoord[0].xy);
	
	// Cloud shadow, only applied to upwards facing surfaces.
	// (gl_TexCoord[1].z contains the normal Y component)
	
	if (gl_TexCoord[1].z > 0.0)
		col.rgb += gl_TexCoord[1].z * (-0.2 + 0.35 * texture2D(cloudShadowTexture, gl_TexCoord[1].xy).rgb);
	
	// Let alpha have a direct effect
	col *= col.a;
	
	gl_FragColor = col * BRIGHTER;
}
